#include <dos.h>
#include "graph.h"

short PC98=0;

/***********************************************************************
***********************************************************************/

// 0=PC/AT 1=9801 2=9821
short chk_machine(void)
{
	static unsigned char str[]="NEC Corporation";
	unsigned char far *rom;
	short i;

	// rom=(unsigned char *)0xe8deel;
	FP_SEG(rom)=0xe800;
	FP_OFF(rom)=0x0dee;
	for(i=0; str[i]; i++){
		if(str[i]!=rom[i]) return 0; // PC-AT
	}

	// rom=(unsigned char *)0x045cl;
	FP_SEG(rom)=0x0000;
	FP_OFF(rom)=0x045c;
	if((*rom)&0x40) return 2; // PC-9821(256F)

	// PC-9801( 16F)
	return 1;
}

/***********************************************************************
***********************************************************************/

void GrpInit(void)
{
	PC98=chk_machine();

	if(PC98) GrpInit98();
	else     GrpInitAT();
}

void GrpTerm(void)
{
	if(PC98) GrpTerm98();
	else     GrpTermAT();
}

void GrpCls(void)
{
	if(PC98) GrpCls98();
	else     GrpClsAT();
}

void GrpPal(int n,int g,int r,int b)
{
	if(PC98) GrpPal98(n,g,r,b);
	else     GrpPalAT(n,g,r,b);
}

void PutAnk(short x,short y,short col,unsigned char *buff)
{
	if(PC98) PutAnk98(x,y,col,buff);
	else     PutAnkAT(x,y,col,buff);
}

void PutKnj(short x,short y,short col,unsigned char *buff)
{
	if(PC98) PutKnj98(x,y,col,buff);
	else     PutKnjAT(x,y,col,buff);
}

void GetFnt(unsigned short code,unsigned char far *buff)
{
	if(PC98) GetFnt98(code,buff);
	else     GetFntAT(code,buff);
}

