#include <stdio.h>
#include "graph.h"

unsigned char ptn[64];

/***********************************************************************
***********************************************************************/

short make0808(void)
{
	unsigned short code;
	short x,y,col;
	FILE *fp;

	fp=fopen("FNT0808.X1","wb");
	if(fp==NULL) return 1;

	x=y=0; col=2;
	for(x=0; x<16; x++) ptn[x]=0;
	for(code=0; code<0x100; code++){
		GetFnt(code,ptn); fwrite(ptn,1,8,fp);
		if(ferror(fp)){ fclose(fp); return 1; }

		PutAnk(x,y,col,ptn);
		x+=1; if(x>=80){ x=0; y++; if(y>=25) y=0; }
	}
	fclose(fp);

	return 0;
}

short make0816(void)
{
	unsigned short code;
	short x,y,col;
	FILE *fp;

	fp=fopen("FNT0816.X1","wb");
	if(fp==NULL) return 1;

	/* ANK (0x1000) */
	x=y=0; col=2;
	for(code=0x8000; code<0x8100; code++){
		GetFnt(code,ptn); fwrite(ptn,1,16,fp);
		if(ferror(fp)){ fclose(fp); return 1; }

		PutAnk(x,y,col,ptn);
		x+=1; if(x>=80){ x=0; y++; if(y>=25) y=0; }
	}
	fclose(fp);

	return 0;
}

short make1616(void)
{
	unsigned short code;
	short x,y,col;
	FILE *fp;

	fp=fopen("FNT1616.X1","wb");
	if(fp==NULL) return 1;

	/* 896 (0x7000) */
	x=0; y=4; col=4;
	for(code=0x8140; code<0x84c0; code++){
		GetFnt(code,ptn); fwrite(ptn,1,32,fp);
		if(ferror(fp)){ fclose(fp); return 1; }

		PutKnj(x,y,col,ptn);
		x+=2; if(x>=80){ x=0; y++; if(y>=25) y=4; }
	}

	/* 6000 (0x2ee00) */
	x=0; y=4; col=6;
	for(code=0x8890; code<0xa000; code++){
		GetFnt(code,ptn); fwrite(ptn,1,32,fp);
		if(ferror(fp)){ fclose(fp); return 1; }

		PutKnj(x,y,col,ptn);
		x+=2; if(x>=80){ x=0; y++; if(y>=25) y=4; }
	}

	/* 2672 (0x14e00) */
	x=0; y=4; col=7;
	for(code=0xe040; code<0xeab0; code++){
		GetFnt(code,ptn); fwrite(ptn,1,32,fp);
		if(ferror(fp)){ fclose(fp); return 1; }

		PutKnj(x,y,col,ptn);
		x+=2; if(x>=80){ x=0; y++; if(y>=25) y=4; }
	}

	fclose(fp);

	return 0;
}

/***********************************************************************
***********************************************************************/

void test_disp(void)
{
	FILE *fp;
	short x,y;

	fp=fopen("FNT0808.X1","rb");
	if(fp==NULL){ printf("Error!\n"); fclose(fp); return; }
	for(x=0; x<16; x++) ptn[x]=0;
	for(y=0; y<16; y++){
		if(ferror(fp)) break;
		for(x=0; x<16; x++){
			if(ferror(fp)) break;
			fread(ptn,1,8,fp); PutAnk(x,y,4,ptn);
		}
	}
	getch(); GrpCls();
	fclose(fp);

	fp=fopen("FNT0816.X1","rb");
	if(fp==NULL){ printf("Error!\n"); fclose(fp); return; }
	for(y=0; y<16; y++){
		if(ferror(fp)) break;
		for(x=0; x<16; x++){
			if(ferror(fp)) break;
			fread(ptn,1,16,fp); PutAnk(x,y,6,ptn);
		}
	}
	getch(); GrpCls();
	fclose(fp);

	fp=fopen("FNT1616.X1","rb");
	if(fp==NULL){ printf("Error!\n"); fclose(fp); return; }
	x=y=0;
	while(!feof(fp)){
		if(ferror(fp)) break;
		fread(ptn,1,32,fp); PutKnj(x,y,7,ptn);
		x+=2;
		if(x>=80){
			x=0; y++;
			if(y>=23){ y=0; getch(); GrpCls(); }
		}
	}
	getch(); GrpCls();

	fclose(fp);
}

/***********************************************************************
***********************************************************************/

void main(int argc,unsigned char *argv[])
{
	GrpInit();
	if(argc==1){
		printf("FNT0808.X1 ... ");
		printf("%s\n",make0808()?"ERROR":"Ok.");
		printf("FNT0816.X1 ... ");
		printf("%s\n",make0816()?"ERROR":"Ok.");
		printf("FNT1616.X1 ... ");
		printf("%s\n",make1616()?"ERROR":"Ok.");
	} else {
		test_disp();
	}
	GrpTerm();
}

