#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>
#include "x1.h"
#include "x1_fdc.h"

/***********************************************************************
	Qct@C̓o
***********************************************************************/

byte FDD_2D[4][80]={0};
byte FLG_2D[4]={0};
word REC_2D[4]={0};
byte BUF_2D[4][256]={0};

//**********************************************************************

short sct_flush_2d(word drv)
{
	FILE *fp;

	if(!FLG_2D[drv]) return 0;
	if(REC_2D[drv]==0xffff) return 0;
	if(REC_2D[drv]>=  1280) return 0;

	fp=fopen(FDD_2D[drv],"r+b");
	if(fp==NULL) return 1;
		fseek(fp,(dword)REC_2D[drv]*256l,SEEK_SET);
		fwrite(BUF_2D[drv],1,256,fp);
	fclose(fp);

	FLG_2D[drv]=0;

	return 0;
}

short scr_set_2d(word drv,word id_c,word id_h,word id_r)
{
	FILE *fp;
	word rec;

	if(id_c>=40) return 1;
	if(id_h>= 2) return 1;
	if(id_r<1 || id_r>16) return 1;

	rec=(id_c*2)+id_h;
	rec=(rec*16)+(id_r-1);
	if(REC_2D[drv]==rec) return 0;

	sct_flush_2d(drv);

	fp=fopen(FDD_2D[drv],"rb");
	if(fp==NULL) return 1;
		fseek(fp,(dword)rec*256l,SEEK_SET);
		fread(BUF_2D[drv],1,256,fp);
	fclose(fp);

	REC_2D[drv]=rec;
	FLG_2D[drv]=0;

	return 0;
}

//**********************************************************************

unsigned char *fdd_name_2d(short drv)
{
	return FDD_2D[drv];
}

short fdd_eject_2d(struct FDC_REGS *fdc,short drv)
{
	if(drv<0 || drv>3) return 1;
	sct_flush_2d(drv);

	FLG_2D[drv]=0;
	REC_2D[drv]=0xffff;
	fdc->img[drv]=0;
	fdc->wpt[drv]=0;

	return 0;
}

short fdd_set_2d(struct FDC_REGS *fdc,short drv,byte *fname)
{
	unsigned atr;

	if(drv<0 || drv>3) return 1;
	fdd_eject_2d(fdc,drv);

	_dos_getfileattr(fname,&atr);
	fdc->wpt[drv]=(atr&_A_RDONLY)?1:0;

	strcpy(FDD_2D[drv],fname);
	fdc->img[drv]=1;

	return 0;
}

//**********************************************************************

short fdd_crc_2d(struct FDC_REGS *fdc)
{
	fdc->crc_dat[0]=(fdc->c);
	fdc->crc_dat[1]=(fdc->h);
	fdc->crc_dat[2]=(fdc->r);
	fdc->crc_dat[3]=(fdc->n);
	fdc->crc_dat[4]=0; // CRC(Lo)
	fdc->crc_dat[5]=0; // CRC(Hi)
	fdc->crc_off=0;
	return 0;
}

byte fdd_stat_2d(struct FDC_REGS *fdc)
{
	byte ans,dmy;
	byte type,cmnd;

	// NOT READY
	if(fdc->img[fdc->drv]!=1) return 0x80;

	ans=0;
	type=(fdc->type);
	cmnd=(fdc->cmnd)>>4;

	if(type==1 || type==4 || cmnd==0x0a || cmnd==0x0b || cmnd==0x0f){
		// WRITE PROTECT
		if(fdc->wpt[fdc->drv]) ans|=0x40;
	}
	if(type==1 || type==4){
		// HEAD ENGAGED (X1   1)
		ans|=0x20;
	}
	if(type==1 || type==2 || cmnd==0x0c){
		// SEEK ERROR / RECORD NOT FOUND
		if(     (fdc->c)>39) ans|=0x10;
		else if((fdc->h)> 1) ans|=0x10;
		else if((fdc->r)< 1) ans|=0x10;
		else if((fdc->r)>16) ans|=0x10;
	}

	if(       type==1 || type==4){
		if((fdc->c)==0) ans|=0x04; // TRACK00
/* x1_fdc.c   
		if((fdc->r)==1) ans|=0x02; // INDEX
*/
	} else if(type==2 || type==3){
		if(!(ans & 0xf0)){
			if((fdc->sct_off)<256) ans|=0x03; // DATA REQUEST / BUSY
		}
	}

	return ans;
}

//**********************************************************************

short inc_off_2d(struct FDC_REGS *fdc)
{
	byte cmnd;

	(fdc->sct_off)++;
	if((fdc->sct_off)<256) return 0;

	cmnd=(fdc->cmnd)>>4;
	if(cmnd==0x09 || cmnd==0x0b){
		if((fdc->r)<16){ (fdc->r)++; (fdc->sct_off)=0; return 0; }
	}

	(fdc->sct_off)=256;

	return 1;
}

//**********************************************************************

byte fdd_read_2d(struct FDC_REGS *fdc)
{
	byte stat,dmy;

	stat=fdd_stat_2d(fdc);
	if(stat & 0xf0) return 0;

	if(scr_set_2d(fdc->drv,fdc->c,fdc->h,fdc->r)) return 0;

	if((fdc->sct_off)>255) return 0;
	return BUF_2D[fdc->drv][fdc->sct_off];
}

void fdd_write_2d(struct FDC_REGS *fdc,byte data)
{
	byte stat,dmy;

	stat=fdd_stat_2d(fdc);
	if(stat & 0xf0) return;

	if(scr_set_2d(fdc->drv,fdc->c,fdc->h,fdc->r)) return;

	if((fdc->sct_off)>255) return;
	BUF_2D[fdc->drv][fdc->sct_off]=data;
	FLG_2D[fdc->drv]=1;
}

//**********************************************************************

short fdd_sct_2d(short drv,short trk,short sct,byte *buff)
{
	// sct  0   +1
	if(scr_set_2d(drv,trk/2,trk&1,sct+1)) return 0;

	memcpy(buff,&BUF_2D[drv],256);

	return 256;
}
