#include <stdio.h>
#include <string.h>
#include <io.h>
#include <i86.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_vram.h"
#include "x1_tape.h"
#include "x1_opm.h"
#include "msdos.h"
#include "debug.h"

static void g_on(void);
static void g_off(void);
static void g_cls(void);
static void t_on(void);
static void t_off(void);
static void t_cls(void);

static byte *GVR_B=(byte *)0xa8000l;
static byte *GVR_R=(byte *)0xb0000l;
static byte *GVR_G=(byte *)0xb8000l;
static byte *GVR_E=(byte *)0xe0000l;

/**********************************************************************
	fobOp
**********************************************************************/

short str_dsp(short x,short y,short col,unsigned char *buf)
{
	static unsigned char *tvr;
	static unsigned char *avr;
	static unsigned char atr,i;
	static unsigned short off;

	atr=(unsigned char)(col%10);
	atr=(atr<<5)|1;
	if(     col>=30) atr|=6;
	else if(col>=20) atr|=2;
	else if(col>=10) atr|=4;

	off=(y*160)+(x*2);
	tvr=(unsigned char *)0xa0000l;
	avr=(unsigned char *)0xa2000l;
	for(i=0; buf[i]; i++){
		avr[off  ]=atr;
		tvr[off++]=buf[i];
		tvr[off++]=0;
	}

	return (x+i);
}

short int_dsp(short x,short y,short col,int dat)
{
	static unsigned char tbl[32]="0123456789ABCDEF";
	static unsigned char str[8];

	str[4]=0;
	str[3]=tbl[dat%10]; dat/=10;
	str[2]=tbl[dat%10]; dat/=10;
	str[1]=tbl[dat%10]; dat/=10;
	str[0]=tbl[dat%10];

	return str_dsp(x,y,col,str);
}

short hex_dsp(short x,short y,short col,int dat)
{
	static unsigned char tbl[32]="0123456789ABCDEF";
	static unsigned char str[8];

	str[4]=0;
	str[3]=tbl[dat&15]; dat>>=4;
	str[2]=tbl[dat&15]; dat>>=4;
	str[1]=tbl[dat&15]; dat>>=4;
	str[0]=tbl[dat&15];

	return str_dsp(x,y,col,str);
}

short byt_dsp(short x,short y,short col,int dat)
{
	static unsigned char tbl[32]="0123456789ABCDEF";
	static unsigned char str[8];

	str[2]=0;
	str[1]=tbl[dat&15]; dat>>=4;
	str[0]=tbl[dat&15];

	return str_dsp(x,y,col,str);
}

/**********************************************************************
	obXW ahnr֐
**********************************************************************/

static void g_on(void)
{
	union REGS r;
	r.h.ah=0x40;
	int386(0x18,&r,&r);
}

static void g_off(void)
{
	union REGS r;
	r.h.ah=0x41;
	int386(0x18,&r,&r);
}

static void g_cls(void)
{
	memset(GVR_B,0,0x8000); memset(GVR_R,0,0x8000);
	memset(GVR_G,0,0x8000); memset(GVR_E,0,0x8000);
}

static void t_on(void)
{
	union REGS r;
	r.h.ah=0x0c;
	int386(0x18,&r,&r);
}

static void t_off(void)
{
	union REGS r;
	r.h.ah=0x0d;
	int386(0x18,&r,&r);
}

static void t_cls(void)
{
	unsigned char *vrm;
	unsigned short i;

	vrm=(unsigned char *)0xa0000l;
	memset(vrm,0,0x2000);

	vrm=(unsigned char *)0xa2000l;
	for(i=0; i<0x2000; i+=2) vrm[i]=0xe1;
}

word kb_sft_98(void)
{
  union REGS r;

	r.h.ah=0x02;
	int386(0x18,&r,&r);

	return (word)r.h.al;
}

word kb_hit_98(void)
{
  union REGS r;

	r.h.ah=0x01;
	int386(0x18,&r,&r);

	return (word)r.h.bh;
}

word kb_get_98(void)
{
  union REGS r;

	r.h.ah=0x00;
	int386(0x18,&r,&r);

	return (word)r.h.ah;
}

/**********************************************************************
	^C}[
**********************************************************************/

static short TCNT=0;
static long  TFRQ=1;

short tcnt_get_98(     void){ return TCNT; }
void  tcnt_set_98(short cnt){ TCNT=cnt; }

void (interrupt far *org_08h_98)(void);

void interrupt far new_08h_98(void)
{
	TCNT++;
	outp(0x00,0x20);
	outp(0x20,0x20);
}

void timer_ini_98(long rate)
{
	// PC-98 8MHzn  1996800ĂłPb
	// PC-98 5MHzn  2457600ĂłPb
	if(inp(0x42)&0x20) TFRQ=1996800l/rate;
	else               TFRQ=2457600l/rate;
	TCNT=0;

	_disable();
	org_08h_98=_dos_getvect(0x08);
	_dos_setvect(0x08,new_08h_98);

	outp(0x02,inp(0x02)|0x01);
	outp(0x77,0x36);
	outp(0x71,TFRQ&0xff);
	outp(0x71,TFRQ>>0x8);
	outp(0x02,inp(0x02)&0xfe);
	_enable();
}

void timer_end_98(void)
{
	_disable();
	outp(0x02,inp(0x02)|0x01);
	if(inp(0x42)&0x20) TFRQ=(unsigned short)(1996800.0/2000.0+0.5);
	else               TFRQ=(unsigned short)(2457600.0/2000.0+0.5);
	outp(0x77,0x76);
	outp(0x3fdb,TFRQ&0xff);
	outp(0x3fdb,TFRQ>>0x8);
	_dos_setvect(0x08,org_08h_98);
	_enable();
}

/**********************************************************************
	L[{[h荞
**********************************************************************/

static byte KEY_INT=0;
static byte KEY_HIT=0;
static byte KEY_CHR=0;

static word *KB_RDP=(word *)0x0524l; /* ̓ǂݍ݈ʒu */
static word *KB_WRP=(word *)0x0526l; /* ݈̏ʒu */
static word *KB_CNT=(word *)0x0528l; /* ǂނׂL[̐   */
static byte *KB_BIT=(byte *)0x052al; /* L[{[h */

void (interrupt _far *old_09h_98)();

void interrupt far new_09h_98(void)
{
	static byte *wp0,*wp1;
	static word r,w,c;
	static byte ks,dmy;

	ks=KB_BIT[0x10];

	r=(*KB_RDP); w=(*KB_WRP); c=(*KB_CNT);
	wp0=(byte *)(*KB_WRP);
		(*old_09h_98)();
	wp1=(byte *)(*KB_WRP);
	(*KB_RDP)=r; (*KB_WRP)=r; (*KB_CNT)=c;

	KEY_INT=1;
	KEY_HIT=(wp0==wp1?0:1);
	KEY_CHR=wp0[1];

	// KM 99'05/18
	if(!KEY_HIT){
		if(ks!=KB_BIT[0x10]){
			KEY_HIT=1; KEY_CHR=0;
		}
	}

	// DEBUGֳ
	SHIFT_KEY=(KB_BIT[0x10]&1);

#if BOSS==1
	if(KEY_HIT){
		if(KEY_CHR==0x51) END_SW=99;
	}
#endif
}

void kb_init_98(void)
{
	unsigned char *byt;

	/* L[s[g̃r[v OFF */
	byt=(unsigned char *)0x500l; (*byt)|=0x20;

	while(kbhit()) getch();

	KEY_INT=0;
	KEY_HIT=0;
	KEY_CHR=0;

	_disable();
	old_09h_98=_dos_getvect(0x09);
	_dos_setvect(0x09,new_09h_98);
	_enable();
}

void kb_reset_98(void)
{
	unsigned char *byt;

	/* L[s[g̃r[v ON */
	byt=(unsigned char *)0x500l; (*byt)&=~0x20;

	_disable();
	_dos_setvect(0x09,old_09h_98);
	_enable();

	while(kbhit()) getch();
}

/**********************************************************************
	L[{[h
**********************************************************************/

//	ް
static byte KC_CONV0[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x1b, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '^',0x5c,0x08,0x09,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
   'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '@', '[',0x0d, 'a', 's', 'd',
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
   'f', 'g', 'h', 'j', 'k', 'l', ';', ':', ']', 'z', 'x', 'c', 'v', 'b', 'n', 'm',
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
   ',', '.', '/', '_',0x20,0xfe,0x0e,0x0f,0x12,0x08,0x1e,0x1d,0x1c,0x1f,0x0c,0xc3,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
   '-', '/', '7', '8', '9',0x2a, '4', '5', '6', '+', '1', '2', '3', '=', '0', ',',
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
   '.',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
	0x13,0x00, 'q', 'r', 's', 't', 'u',0xec,0xeb,0xe2,0xe1,0xe8,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

// 
static byte KC_CONV1[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x1b, '!',0x22, '#', '$',0x25, '&',0x27, '(', ')', '0', '=',0x60,0x7c,0x12,0x09,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
   'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P',0x7e, '{',0x0d, 'A', 'S', 'D',
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
   'F', 'G', 'H', 'J', 'K', 'L', '+',0x2a, '}', 'Z', 'X', 'C', 'V', 'B', 'N', 'M',
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
   '<', '>',0x3f, '_',0x20,0xfe,0x0e,0x0f,0x12,0x08,0x1e,0x1d,0x1c,0x1f,0x0b,0xc5,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
   '-', '/', '7', '8', '9',0x2a, '4', '5', '6', '+', '1', '2', '3', '=', '0', ',',
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
   '.',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
  0x03,0x00, 'v', 'w', 'x', 'y', 'z',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

// GRPH
static byte KC_CONV2[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x00,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0x8c,0x8b,0xfb,0x00,0x00,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
  0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xf0,0x8d,0x8a,0xfc,0x00,0x7f,0xe9,0xea,
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
  0xeb,0xec,0xed,0xee,0xef,0x8e,0x89,0xfd,0xe8,0x80,0x81,0x82,0x83,0x84,0x85,0x86,
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
  0x87,0x88,0xfe,0xff,0x00,0xfe,0x0e,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
  0x9c,0x9e,0x9a,0x93,0x97,0x9b,0x95,0x96,0x94,0x9d,0x99,0x92,0x98,0x90,0x8f,0x9f,
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x91,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

// CTRL
static byte KC_CONV3[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x1b, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0',0x00,0x1e,0x1c,0x08,0x09,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
  0x11,0x17,0x05,0x12,0x14,0x19,0x15,0x09,0x0f,0x10, '@',0x1b,0x0d,0x01,0x13,0x04,
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
  0x06,0x07,0x08,0x0a,0x0b,0x0c, ';', ':',0x1d,0x1a,0x18,0x03,0x16,0x02,0x0e,0x0d,
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
  0x00,0x00,0x00,0x1f, ' ',0xff,0x0e,0x0f,0x12,0x08,0x1e,0x1d,0x1c,0x1f,0x0b,0xc5,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
   '-', '/', '7', '8', '9',0x2a, '4', '5', '6', '+', '1', '2', '3', '=', '0', ',',
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
   '.',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
  0x13,0x00,0x00,0x00,0x00,0x00,0x00,0xec,0xeb,0xe2,0xe1,0xe8,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

// 
static byte KC_CONV4[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x1b, '', '', '', '', '', '', '', '', '', '', '', '', '',0x08,0x09,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
   '', '', '', '', '', '', '', '', '', '', '', '',0x0d, '', '', '',
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
   '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
   '', '', '', '',0x20,0xfe,0x0e,0x0f,0x12,0x08,0x1e,0x1d,0x1c,0x1f,0x0b,0xc5,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
   '-', '/', '7', '8', '9',0x2a, '4', '5', '6', '+', '1', '2', '3', '=', '0', ',',
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
   '.',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
  0x13,0x00, 'q', 'r', 's', 't', 'u',0xec,0xeb,0xe2,0xe1,0xe8,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

// +
static byte KC_CONV5[]={
/*ESC , P , Q , R , S , T , U , V , W , X , O , | , O ,  ,ar,TAB */
  0x1b, '', '', '', '', '', '', '', '', '', '', '', '', '',0x12,0x09,
/* p , v , d , q , s , x , t , h , n , o ,  , m ,, ` , r , c */
   '', '', '', '', '', '', '', '', '', '', '', '',0x0d, '', '', '',
/* e , f , g , i , j , k , G , F , n , y , w , b , u , a , m , l */
   '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
/*  C, D , ^ , Q ,SPC ,XFER,R UP,RDWN,INS ,DEL ,  ,  ,  ,  ,HOME,HELP*/
   '', '', '', '',0x20,0xfe,0x0e,0x0f,0x12,0x08,0x1e,0x1d,0x1c,0x1f,0x0b,0xc5,
/*<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>,<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>*/
   '-', '/', '7', '8', '9',0x2a, '4', '5', '6', '+', '1', '2', '3', '=', '0', ',',
/*<D>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,    ,    ,    ,    ,    ,    ,    ,    ,    */
   '.',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*STOP,COPY,f.1 ,f.2 ,f.3 ,f.4 ,f.5 ,f.6 , f.7,f.8 ,f.9 ,f.10,    ,    ,    ,    */
  0x03,0x00, 'v', 'w', 'x', 'y', 'z',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/*SHFT,CAPA,Ji,GRPH,CTRL,    ,    ,    ,    ,    ,    ,    ,    ,    ,    ,    */
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

short key_int_chk_98(void){ return (short)KEY_INT; }
void  key_int_clr_98(void){ KEY_INT=0; }

void key_get_98(byte *sft,byte *chr)
{
	byte kc,ks;

	(*sft)=0xff; (*chr)=0x00;
	if(!KEY_HIT) return;

	kc=KEY_CHR;
	ks=KB_BIT[0x10];

	(*sft)=(0xff^0x40);
	if(ks & 0x10) (*sft)^=0x01; // ctrl
	if(ks & 0x01) (*sft)^=0x02; // shift
	if(ks & 0x04) (*sft)^=0x04; // kana
	if(ks & 0x02) (*sft)^=0x08; // caps
	if(ks & 0x08) (*sft)^=0x10; // graph

	// f.1-f.10
	if(     kc>=0x62 && kc<=0x6b){ (*sft)^=0x80; }
	else if(kc>=0x82 && kc<=0x8b){ (*sft)^=0x80; kc-=0x20; }
	else if(kc>=0x92 && kc<=0x9b){ (*sft)^=0x80; kc-=0x30; }
	// 10-Key
	if(kc>=0x3e && kc<=0x50) (*sft)^=0x80;

	kc&=0x7f;

	if(ks & 0x04){ // kana
		if(ks & 0x01) (*chr)=KC_CONV5[kc];
		else          (*chr)=KC_CONV4[kc];
	} else {
		if(     ks & 0x10) (*chr)=KC_CONV3[kc]; // ctrl
		else if(ks & 0x08) (*chr)=KC_CONV2[kc]; // grph
		else {
			if(ks & 0x01) (*chr)=KC_CONV1[kc]; // shift
			else          (*chr)=KC_CONV0[kc];
			if(ks & 0x02){ // caps
				if(     (*chr)>='a' && (*chr)<='z') (*chr)^=0x20;
				else if((*chr)>='A' && (*chr)<='Z') (*chr)^=0x20;
			}
		}
	}
}

void game_key_98(byte *tbl)
{
	#define hit_chk(kc) (KB_BIT[(kc)>>3]&(1<<((kc)&7)))

	tbl[0]=tbl[1]=tbl[2]=0;
	if(hit_chk(0x10)) tbl[0]|=0x80; //  Q 
	if(hit_chk(0x11)) tbl[0]|=0x40; //  W 
	if(hit_chk(0x12)) tbl[0]|=0x20; //  E 
	if(hit_chk(0x1d)) tbl[0]|=0x10; //  A 
	if(hit_chk(0x1f)) tbl[0]|=0x08; //  D 
	if(hit_chk(0x29)) tbl[0]|=0x04; //  Z 
	if(hit_chk(0x2a)) tbl[0]|=0x02; //  X 
	if(hit_chk(0x2b)) tbl[0]|=0x01; //  C 

	if(hit_chk(0x42)) tbl[1]|=0x80; // [7]
	if(hit_chk(0x46)) tbl[1]|=0x40; // [4]
	if(hit_chk(0x4a)) tbl[1]|=0x20; // [1]
	if(hit_chk(0x43)) tbl[1]|=0x10; // [8]
	if(hit_chk(0x4b)) tbl[1]|=0x08; // [2]
	if(hit_chk(0x44)) tbl[1]|=0x04; // [9]
	if(hit_chk(0x48)) tbl[1]|=0x02; // [6]
	if(hit_chk(0x4c)) tbl[1]|=0x01; // [3]

	if(hit_chk(0x00)) tbl[2]|=0x80; // ESC
	if(hit_chk(0x01)) tbl[2]|=0x40; //  1 
	if(hit_chk(0x40)) tbl[2]|=0x20; // [-]
	if(hit_chk(0x49)) tbl[2]|=0x10; // [+]
	if(hit_chk(0x45)) tbl[2]|=0x08; // [*]
	if(hit_chk(0x0f)) tbl[2]|=0x04; // TAB
	if(hit_chk(0x34)) tbl[2]|=0x02; // SPC
	if(hit_chk(0x1c)) tbl[2]|=0x01; // RET
}

byte joy_key_98(void)
{
	byte joy;

	joy=0;
	if(KB_BIT[0x07] & 0x04) joy|=0x01; // 
	if(KB_BIT[0x07] & 0x20) joy|=0x02; // 
	if(KB_BIT[0x07] & 0x08) joy|=0x04; // 
	if(KB_BIT[0x07] & 0x10) joy|=0x08; // 
	if(KB_BIT[0x05] & 0x04) joy|=0x20; // `
	if(KB_BIT[0x05] & 0x02) joy|=0x40; // a

	return (joy^0xff);
}

void exkey_98(void)
{
	if(       KB_BIT[0x0c] & 0x80){ // f.6
		if(KB_BIT[0x10]&1) cmt_apss_rew();
		else cmt_rew();
	} else if(KB_BIT[0x0d] & 0x01){ // f.7
		if(KB_BIT[0x10]&1) cmt_eject();
		else if(cmt_cntl_stat()!=0x01) cmt_play();
		else                           cmt_stop();
	} else if(KB_BIT[0x0d] & 0x02){ // f.8
		if(KB_BIT[0x10]&1) cmt_apss_ff();
		else cmt_ff();
	} else if(KB_BIT[0x0d] & 0x04){ // f.9
		cmt_disp_sw(2);
	} else if(KB_BIT[0x0d] & 0x08){ // f.10
		if(KB_BIT[0x10]&1){
			debug_sw(debug_chk()?0:1);
		} else END_SW=1;
	}
	while(KB_BIT[0x0c] & 0x80);
	while(KB_BIT[0x0d] & 0x0f);
}

/***********************************************************************
	
***********************************************************************/

short v_blank_98(void)
{
	return (inp(0x60)&0x20)?1:0;
}

void palet_98(int n,int g,int r,int b)
{
	outp(0xa8,n); outp(0xaa,g);
	outp(0xac,r); outp(0xae,b);
}

void put_line_98(word x,word y,word l,struct GPTN *ptn)
{
	word off;
	off=(y*80)+x;
	memcpy(&GVR_B[off],ptn->b,l); memcpy(&GVR_R[off],ptn->r,l);
	memcpy(&GVR_G[off],ptn->g,l); memcpy(&GVR_E[off],ptn->m,l);
}

void put_font_98(short x,short y,struct GPTN *ptn)
{
	word i,off;

	off=(x+(y*1280));
	for(i=0; i<16; i++){
		GVR_B[off]=ptn->b[i]; GVR_R[off]=ptn->r[i];
		GVR_G[off]=ptn->g[i]; GVR_E[off]=ptn->m[i];
		off+=80;
	}
}

void put88_98(short x,short y,struct GPTN *ptn)
{
	word i,off;

	off=(x+(y*640));
	for(i=0; i<8; i++){
		GVR_B[off]=ptn->b[i]; GVR_R[off]=ptn->r[i];
		GVR_G[off]=ptn->g[i]; GVR_E[off]=ptn->m[i];
		off+=80;
	}
}

/**********************************************************************
	^I
**********************************************************************/

word init_98(void)
{
	union REGS r;
	short i;

	r.h.ah=0x12; int386(0x18,&r,&r); // CURSOR OFF

	// 640x400
	r.h.ah=0x42; r.h.ch=0xc0;
	int386(0x18,&r,&r);
	outp(0x6a,1); // 16 color
	outp(0xa4,0); // display page 0
	outp(0xa6,0); // draw    page 0

	for(i=0; i<16; i++){
		palet(i,(i&4?15:0),(i&2?15:0),(i&1?15:0));
	}

	g_on(); g_cls();
	t_on(); t_cls();

	kb_init_98();

	return 0;
}

void term_98(void)
{
  union REGS r;

	r.h.ah=0x0a; r.h.al=0;
	int386(0x18,&r,&r);
	outp(0x68,0x07); // 7x13 FONT

	g_cls(); g_off();
	t_cls(); t_on();

	r.h.ah=0x11; int386(0x18,&r,&r); // CURSOR ON

	kb_reset_98();
}

