#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include <dos.h>
#include "x1.h"
#include "msdos.h"
#include "x1_pcg.h"
#include "x1_crtc.h"
#include "x1_vram.h"
#include "text.h"

short kanji_chk(byte code)
{
	if(code>=0x81 && code<=0x9f) return 1;
	if(code>=0xe0 && code<=0xfc) return 1;
	return 0;
}

void bank_set(struct GPTN *crt,short bnk)
{
	if(       bnk==0){
		(crt->b)=CRT_B00; (crt->r)=CRT_R00;
		(crt->g)=CRT_G00; (crt->m)=CRT_M00;
	} else if(bnk==1){
		(crt->b)=CRT_B01; (crt->r)=CRT_R01;
		(crt->g)=CRT_G01; (crt->m)=CRT_M01;
	} else if(bnk==2){
		(crt->b)=CRT_B02; (crt->r)=CRT_R02;
		(crt->g)=CRT_G02; (crt->m)=CRT_M02;
	} else {
		(crt->b)=CRT_B03; (crt->r)=CRT_R03;
		(crt->g)=CRT_G03; (crt->m)=CRT_M03;
	}
}

short line_set(struct GPTN *ptn,short bank,word y)
{
	word off;

	off=VTOP_TBL[y];
	if(off+TXT_XL>0x4000) return 0;

	bank_set(ptn,bank);
	(ptn->b)+=off; (ptn->r)+=off;
	(ptn->g)+=off; (ptn->m)+=off;

	return 1;
}

/***********************************************************************
	OtBbNʂɂP\
***********************************************************************/

static void bitset(byte *des,byte *src,short cnt)
{
	while(cnt--) (*des++)|=(*src++);
}

static void bitclr(byte *des,byte *src,short cnt)
{
	while(cnt--) (*des++)&=~(*src++);
}

// AN
void ank_put(short x,short y,short col,word code)
{
	byte buf0[16],buf1[16],buf2[16];
	struct GPTN ptn;
	byte *fnt;

	fnt=KNJ_FNT; fnt+=(code*16);

	if(col&0x10) memset(buf0,0xff,16); else memset(buf0,0x00,16);
	if(col&0x20) memset(buf1,0xff,16); else memset(buf1,0x00,16);
	if(col&0x40) memset(buf2,0xff,16); else memset(buf2,0x00,16);
	if(col&0x01) bitset(buf0, fnt,16); else bitclr(buf0, fnt,16);
	if(col&0x02) bitset(buf1, fnt,16); else bitclr(buf1, fnt,16);
	if(col&0x04) bitset(buf2, fnt,16); else bitclr(buf2, fnt,16);

	ptn.b=buf0; ptn.r=buf1;
	ptn.g=buf2; ptn.m=DMY_FF;
	put_font(x,y,&ptn);
}

// 
void knj_put(short x,short y,short col,word code)
{
	byte buf0[16],buf1[16],buf2[16];
	byte fnt0[16],fnt1[16];
	struct GPTN ptn;
	byte *fnt;
	short i;

	fnt=KNJ_FNT;
	if(       code>=0x8140 && code<0x84c0){
		fnt+=0x01000l; fnt+=(long)(code-0x8140)*32l;
	} else if(code>=0x8890 && code<0xa000){
		fnt+=0x08000l; fnt+=(long)(code-0x8890)*32l;
	} else if(code>=0xe040 && code<0xeab0){
		fnt+=0x36e00l; fnt+=(long)(code-0xe040)*32l;
	} else {
		fnt+=0x01000l;
	}

	for(i=0; i<16; i++){
		fnt0[i]=(*fnt++);
		fnt1[i]=(*fnt++);
	}

	ptn.b=buf0; ptn.r=buf1;
	ptn.g=buf2; ptn.m=DMY_FF;

	if(col&0x10) memset(buf0,0xff,16); else memset(buf0,0x00,16);
	if(col&0x20) memset(buf1,0xff,16); else memset(buf1,0x00,16);
	if(col&0x40) memset(buf2,0xff,16); else memset(buf2,0x00,16);
	if(col&0x01) bitset(buf0,fnt0,16); else bitclr(buf0,fnt0,16);
	if(col&0x02) bitset(buf1,fnt0,16); else bitclr(buf1,fnt0,16);
	if(col&0x04) bitset(buf2,fnt0,16); else bitclr(buf2,fnt0,16);
	put_font(x,y,&ptn);
	if(col&0x10) memset(buf0,0xff,16); else memset(buf0,0x00,16);
	if(col&0x20) memset(buf1,0xff,16); else memset(buf1,0x00,16);
	if(col&0x40) memset(buf2,0xff,16); else memset(buf2,0x00,16);
	if(col&0x01) bitset(buf0,fnt1,16); else bitclr(buf0,fnt1,16);
	if(col&0x02) bitset(buf1,fnt1,16); else bitclr(buf1,fnt1,16);
	if(col&0x04) bitset(buf2,fnt1,16); else bitclr(buf2,fnt1,16);
	put_font(x+1,y,&ptn);
}

/***********************************************************************
	wP̉zuq`lP\
***********************************************************************/

void crt_put(short x,short y)
{
	byte buf0[16],buf1[16];
	byte buf2[16],buf3[16];
	struct GPTN ptn,p0,p1;
	short gx,gy,i,n;
	word off;

	memset(buf0,0,16); memset(buf1,0,16);
	memset(buf2,0,16); memset(buf3,0,16);

	gx=(CRT_H320?(TXT_XL*2):TXT_XL);
	gy=(y*8)+7;
	if(x<gx && gy<CRT_YL){
		n=(CRT_BANK*2);
		if(     CRT_V400==0){ bank_set(&p0,n); bank_set(&p1,n); }
		else if(CRT_V400==1){ bank_set(&p0,0); bank_set(&p1,1); }
		else if(CRT_V400==3){ bank_set(&p0,n); bank_set(&p1,n+1); }
		n=0; gy=(y*8); gx=(CRT_H320?(x/2):x);
		for(i=0; i<8; i++){
			off=VTOP_TBL[gy]+gx; gy++;
			buf0[n]=p0.b[off]; buf1[n]=p0.r[off];
			buf2[n]=p0.g[off]; buf3[n]=p0.m[off];
			n++;
			if(CRT_V400){
				buf0[n]=p1.b[off]; buf1[n]=p1.r[off];
				buf2[n]=p1.g[off]; buf3[n]=p1.m[off];
			}
			n++;
		}
	}

	if(CRT_H320){
		if(x&1){
			for(i=0; i<16; i++){
				buf0[i]=X2TBL1[buf0[i]]; buf1[i]=X2TBL1[buf1[i]];
				buf2[i]=X2TBL1[buf2[i]]; buf3[i]=X2TBL1[buf3[i]];
			}
		} else {
			for(i=0; i<16; i++){
				buf0[i]=X2TBL0[buf0[i]]; buf1[i]=X2TBL0[buf1[i]];
				buf2[i]=X2TBL0[buf2[i]]; buf3[i]=X2TBL0[buf3[i]];
			}
		}
	}

	ptn.b=buf0; ptn.r=buf1;
	ptn.g=buf2; ptn.m=buf3;
	put_font(x,y,&ptn);
}

/***********************************************************************
	OtBbNʂɕ\
***********************************************************************/

void etext(word x,word y,word l,word col,byte *str)
{
	word code;

	if(y  >25) return;
	if(x+l>80) l=(80-x);

	if(!col){
		while(l--) crt_put(x++,y);
		return;
	}

	if(str!=NULL){
		while(l && *str){
			if(kanji_chk(*str)){
				if(l<2){
					ank_put(x,y,col,0x20); str+=2; x++; l--;
				} else {
					code=(*str++); code<<=8; code|=(*str++);
					knj_put(x,y,col,code); x+=2; l-=2;
				}
			} else {
				ank_put(x,y,col,*str++); x++; l--;
			}
		}
	}
	while(l--) ank_put(x++,y,col,0x20);
}

/***********************************************************************
	j[p@Tu[`
***********************************************************************/

void bar_ini_h(short x,short y,byte *str[],struct MENU_BAR *tbl)
{
	short l,n;

	for(n=0; str[n]!=NULL; n++){
		for(l=0; str[n][l]; l++);
		tbl[n].str=str[n];
		tbl[n].x=x; tbl[n].y=y;
		tbl[n].l=l; tbl[n].c=0;
		x+=(l+1);
	}
	tbl[n].str=NULL;
}

void bar_ini_v(short x,short y,byte *str[],struct MENU_BAR *tbl)
{
	short i,l,n;

	l=0;
	for(n=0; str[n]!=NULL; n++){
		for(i=0; str[n][i]; i++);
		if(i>l) l=i;
		tbl[n].str=str[n];
		tbl[n].x=x; tbl[n].y=y+n;
		tbl[n].l=0; tbl[n].c=0;
	}
	tbl[n].str=NULL;
	for(i=0; i<n; i++) tbl[i].l=l;
}

void bar_disp(struct MENU_BAR *tbl)
{
	etext(tbl->x,tbl->y,tbl->l,tbl->c?0x26:0x70,tbl->str);
}

void menu_dsp(struct MENU_BAR *tbl)
{
	short i;
	for(i=0; tbl[i].str!=NULL; i++) bar_disp(&tbl[i]);
}

void menu_clr(struct MENU_BAR *tbl)
{
	short i;
	for(i=0; tbl[i].str!=NULL; i++){
		etext(tbl[i].x,tbl[i].y,tbl[i].l,0,NULL);
	}
}

short menu_key(short *x,short *y)
{
	short sw;
	byte sft,asc;

	(*x)=(*y)=sw=0;

	while(!key_int_chk());
	key_int_clr();
	key_get_x1(&sft,&asc);

	switch(asc){
		case 0x1b:   sw|=2; break; // esc
		case 0x0d:   sw|=1; break; // enter
		case 0x20:   sw|=1; break; // space
		case 0x1e: (*y)=-1; break; // u
		case 0x1f: (*y)= 1; break; // d
		case 0x1d: (*x)=-1; break; // l
		case 0x1c: (*x)= 1; break; // r
		case 0x0f: (*y)=-5; break; // R-DOWN
		case 0x0e: (*y)= 5; break; // R-UP
	}

	return sw;
}

short menu_sel(short hv,struct MENU_BAR *tbl,short *no)
{
	short num,bak;
	short cnt,btm,i;
	short jx,jy,jsw;

	num=0;
	for(cnt=0; tbl[cnt].str!=NULL; cnt++){
		if(tbl[cnt].c) num=cnt;
	}
	btm=(cnt-1);
	tbl[num].c=1;

	for(i=0; i<cnt; i++) bar_disp(&tbl[i]);

	for(;;){
		jsw=menu_key(&jx,&jy);
		if(END_SW) break;
		if(     jsw&1){ jsw=0; break; }
		else if(jsw&2){ jsw=1; break; }

		bak=num;
		if(hv){
			if(     jx==-1){ jsw=2; break; }
			else if(jx== 1){ jsw=3; break; }
			num+=jy;
		} else {
			num+=jx;
		}
		if(     num<  0) num=(hv?0:btm);
		else if(num>btm) num=(hv?btm:0);
		if(num!=bak){
			tbl[bak].c=0; bar_disp(&tbl[bak]);
			tbl[num].c=1; bar_disp(&tbl[num]);
		}
	}

	(*no)=num;

	return jsw;
}

/***********************************************************************
	alo@r`ud
***********************************************************************/

void ptn2bmp(struct GPTN *ptn,byte *buff)
{
	word x,xl,off;
	byte b,r,g,m,c;
	byte sw,bit,dmy;

	off=sw=0;
	for(x=0; x<TXT_XL; x++){
		b=ptn->b[x]; r=ptn->r[x];
		g=ptn->g[x]; m=ptn->m[x];
		for(bit=0x80; bit; bit>>=1){
			c=0;
			if(b & bit) c|=1;
			if(r & bit) c|=2;
			if(g & bit) c|=4;
			if(!(m&bit)) c=PAL_TBL[c];
			if(CRT_H320){
				buff[off]=(c<<4);
				buff[off++]|=c;
			} else {
				if(!sw) buff[off]=(c<<4);
				else buff[off++]|=c;
				sw^=1;
			}
		}
	}
}

void bmp_line(short bank,word y,byte *buff)
{
	struct GPTN ptn;

	memset(buff,0,320);
	if(line_set(&ptn,bank,y)) ptn2bmp(&ptn,buff);
}

//----------------------------------------------------------------------

typedef struct BMP_FILE_HED {
	unsigned short bfType;
	unsigned long  bfSize;
	unsigned short bfReserved1;
	unsigned short bfReserved2;
	unsigned long  bfOffBits;
} BMP_F_HED;

typedef struct BMP_INFO_HED {
	unsigned long  biSize;
	unsigned long  biWidth;
	unsigned long  biHeight;
	unsigned short biPlanes;
	unsigned short biBitCount;
	unsigned long  biCompression;
	unsigned long  biSizeImage;
	unsigned long  biXPelsPerMeter;
	unsigned long  biYPelsPerMeter;
	unsigned long  biClrUsed;
	unsigned long  biClrImportant;
} BMP_I_HED;

BMP_F_HED BFH;
BMP_I_HED BIH;

void bmp_hed_clr(BMP_F_HED *fh,BMP_I_HED *ih,short bit,short pal,short xl,short yl)
{
	fh->bfType     =0x4d42; /* ID ('B','M') */
	fh->bfSize     =0l;     /* file size    */
	fh->bfReserved1=0;      /* reserved     */
	fh->bfReserved2=0;      /* reserved     */
	fh->bfOffBits  =0l;

	ih->biSize         =sizeof(BMP_I_HED); /* header size */
	ih->biWidth        =0l; /* width  */
	ih->biHeight       =0l; /* height */
	ih->biPlanes       =1;  /* planes */
	ih->biBitCount     =0;  /* bit count     */
	ih->biCompression  =0l; /* compression   */
	ih->biSizeImage    =0l; /* size of image */
	ih->biXPelsPerMeter=0l; /* x-resolution  */
	ih->biYPelsPerMeter=0l; /* y-resolution  */
	ih->biClrUsed      =0l; /* color index count     */
	ih->biClrImportant =0l; /* important index count */

	ih->biBitCount=bit;
	ih->biClrUsed =pal;
	ih->biWidth   = xl;
	ih->biHeight  = yl;

	ih->biSizeImage =ih->biWidth;
	ih->biSizeImage*=ih->biHeight;
	if(     bit==24) ih->biSizeImage*=3;
	else if(bit== 4) ih->biSizeImage/=2;

	fh->bfOffBits =sizeof(BMP_F_HED);
	fh->bfOffBits+=sizeof(BMP_I_HED);
	fh->bfOffBits+=(unsigned long)pal*4l;

	fh->bfSize=fh->bfOffBits+ih->biSizeImage;
}

short bmp_save(void)
{
	byte buf[320];
	struct RGB {
		unsigned char b;
		unsigned char g;
		unsigned char r;
		unsigned char x;
	} pal;
	short i,n;
	FILE *fp;

	sprintf(buf,"%sX1CG%04d.BMP",PRG_PATH,BMP_NUM);

	fp=fopen(buf,"wb");
	if(fp==NULL) return 1;

	for(i=0; i<0x800; i++) txt_update(i);

	bmp_hed_clr(&BFH,&BIH,4,16,640,400);
	fwrite(&BFH,1,sizeof(BMP_F_HED),fp);
	fwrite(&BIH,1,sizeof(BMP_I_HED),fp);
	for(i=0; i<16; i++){
		pal.b=(i&1?255:0); pal.r=(i&2?255:0);
		pal.g=(i&4?255:0); pal.x=0;
		fwrite(&pal,1,4,fp);
	}
	if(ferror(fp)){ fclose(fp); return 2; }

	if(       CRT_V400==0){
		for(i=199; i>=0; i--){
			bmp_line(CRT_BANK*2,i,buf);
			fwrite(buf,1,320,fp);
			fwrite(buf,1,320,fp);
			if(ferror(fp)){ fclose(fp); return 2; }
		}
	} else if(CRT_V400==1){
		for(i=199; i>=0; i--){
			bmp_line(1,i,buf); fwrite(buf,1,320,fp);
			bmp_line(0,i,buf); fwrite(buf,1,320,fp);
			if(ferror(fp)){ fclose(fp); return 2; }
		}
	} else if(CRT_V400==3){
		n=CRT_BANK*2;
		for(i=199; i>=0; i--){
			bmp_line(n+1,i,buf); fwrite(buf,1,320,fp);
			bmp_line(n  ,i,buf); fwrite(buf,1,320,fp);
			if(ferror(fp)){ fclose(fp); return 2; }
		}
	}

	fclose(fp);

	BMP_NUM=(BMP_NUM+1)%10000;

	return 0;
}

