#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <i86.h>
#include <fcntl.h>
#include <direct.h>
#include <sys\stat.h>
#include "x1.h"
#include "x1_opm.h"
#include "x1_psg.h"
#include "x1_pcg.h"
#include "x1_crtc.h"
#include "x1_vram.h"
#include "x1_ctc.h"
#include "x1_sio.h"
#include "x1_dma.h"
#include "x1_fdc.h"
#include "x1_tape.h"
#include "x1_scpu.h"
#include "x1_8255.h"
#include "joypad.h"
#include "msdos.h"
#include "text.h"
#include "config.h"
#include "debug.h"

unsigned char Title[80]="X1EMU <Ver 0.5>";
unsigned char PRG_PATH[80]={0};

byte *RAM0=NULL;
byte *RAM1=NULL;
byte *KNJ_FNT=NULL;

struct SND_PRM far *SndPrm=NULL;
word  OPMDRV_IRQ=0x6a;

// 0=ż 1=OPMDRV 2=X1SND
short OPM_MODE=0;
short PSG_MODE=0;

short PC98FLG=0;
short KEY_MODE=0;
short SOUND_SW=1;

short END_SW=0;
short MENU_SW=1;
short BMP_NUM=0;

short DIP_SW=0x00;

short ROM_TYPE=2;
short ROM_SW=1;
short ROM_SW_VAL=1;
short IO_MODE=0;

short SYNC_MODE=0;
short V_DISP=0; // 8255(B)(IO-1900H) Bit7
short V_SYNC=0; // 8255(B)(IO-1900H) Bit2

short VSYNC_FLG=0; // V-SYNCONAtO
short H_CNT=0; // X^̕\Jno߂Xe[g
short V_CNT=0; // \̃X^ԍ

short DRAW_SKIP=0;

word WAITFLG=1;
word VSYNC_98=5642; // XŴu|rxmb
word VSYNC_AT=6000; // `ŝu|rxmb
// word VSYNC_AT=5995; // `ŝu|rxmb
word VSYNC_TM=6000; // ^C}[EFCgp

short IPL_SKIP=0;
short SOFT_NUM=0;

short SHIFT_KEY=0; // DEBUGֳ

//**********************************************************************

byte PCG_B[256][8];
byte PCG_R[256][8];
byte PCG_G[256][8];

byte ANK_FNT[256][8];

byte X2TBL0[256];
byte X2TBL1[256];
word X2TBLW[256];

byte DMY_00[256]; // 0x00256oCgKvȂƂQƂ
byte DMY_FF[256]; // 0xff256oCgKvȂƂQƂ

byte MAIN0[0x8000]; // 0000-7fff Ҳݥذ
byte MAIN1[0x8000]; // 8000-ffff Ҳݥذ

byte BIOS[0x8000];     // 0000-7fff IPL & BIOS ROM
byte BANK[16][0x8000]; // 0000-7fff RAM 16ݸ

byte TXT_ATR[0x800];
byte TXT_ANK[0x800];
byte TXT_KAN[0x800];

byte GRP_B00[0x4000],GRP_R00[0x4000],GRP_G00[0x4000],GRP_M00[0x4000];
byte GRP_B01[0x4000],GRP_R01[0x4000],GRP_G01[0x4000],GRP_M01[0x4000];
byte TXT_B00[0x4000],TXT_R00[0x4000],TXT_G00[0x4000],TXT_M00[0x4000];
byte TXT_B01[0x4000],TXT_R01[0x4000],TXT_G01[0x4000],TXT_M01[0x4000];
byte CRT_B00[0x4000],CRT_R00[0x4000],CRT_G00[0x4000],CRT_M00[0x4000];
byte CRT_B01[0x4000],CRT_R01[0x4000],CRT_G01[0x4000],CRT_M01[0x4000];
byte CRT_B02[0x4000],CRT_R02[0x4000],CRT_G02[0x4000],CRT_M02[0x4000];
byte CRT_B03[0x4000],CRT_R03[0x4000],CRT_G03[0x4000],CRT_M03[0x4000];
byte CRT_F00[0x4000],CRT_F01[0x4000];

// byte IOr[0x2000];
// byte IOw[0x2000];

/***********************************************************************
	nol@g[X
------------------------------------------------------------------------
	FMgpWX^g PSGނ悤ɂ܂
	reg = 2 / dat = psgreg
	reg = 3 / dat = psgdat
	reg 4`7  - reserved
***********************************************************************/

static FILE *opmh=NULL;
static word ym2151counter = 0;
static short bufcnt=0;
static word opmbuf[256];

static byte fmop[256]={0};
static byte psgop[14]={0};

//----------------------------------------------------------------------

short opm_trace_chk(void)
{
	return (opmh==NULL?0:1);
}

void opm_trace_init(void)
{
	memset(fmop ,0,256);
	memset(psgop,0, 14);
}

static void setopmbuf(word val)
{
	opmbuf[bufcnt++]=val;
	if(bufcnt>=256){
		fwrite(opmbuf,2,256,opmh);
		bufcnt=0;
	}
}

//----------------------------------------------------------------------

void opm_trace_start(void)
{
	byte fname[16];
	short i;

	if(opmh!=NULL) return;

	for(i=0; i<100; i++){
		sprintf(fname,"OPMREG%02d.X1F",i);
		if(access(fname,0)) break;
	}

	ym2151counter=0;

	opmh=fopen(fname,"wb");
	if(opmh==NULL) return;

	bufcnt=0;
	memcpy(fmop,"X1F",4);
	fwrite(fmop,1,256,opmh);
	for(i=0; i<14; i++){
		setopmbuf(0x0200|i);
		setopmbuf(0x0300|psgop[i]);
	}
}

void opm_trace_end(void)
{
	if(opmh==NULL) return;

	if(bufcnt){
		fwrite(opmbuf,2,bufcnt,opmh);
		bufcnt=0;
	}

	fclose(opmh);
	opmh=NULL;
}

//----------------------------------------------------------------------

void opm_trace_cnt(void)
{
	ym2151counter++;
}

void opm_trace_reg(byte reg,byte val)
{
	word w;

	if(reg<8 && reg!=1) return; // 8̃WX^͐GȂ

	fmop[reg]=val;
	if(opmh==NULL) return;

	if(ym2151counter){
		if(ym2151counter & 0xff00) setopmbuf(0);
		setopmbuf(ym2151counter);
		ym2151counter=0;
	}

	w =(word)reg; w<<=8;
	w|=(word)val;
	setopmbuf(w);
}

void psg_trace_reg(byte reg,byte val)
{
	if(reg>=14) return;

	psgop[reg]=val;
	if(opmh==NULL) return;

	if(ym2151counter){
		if(ym2151counter & 0xff00) setopmbuf(0);
		setopmbuf(ym2151counter);
		ym2151counter=0;
	}
	setopmbuf(0x0200|reg);
	setopmbuf(0x0300|val);
}

/***********************************************************************
	IPL-ROM LOAD
***********************************************************************/

short ipl_load(void)
{
	byte str[80];
	FILE *fp;

	memset(BIOS,0,0x8000);

	if(ROM_TYPE==2){
		strcpy(str,PRG_PATH); strcat(str,"IPLROM.X1T");
		fp=fopen(str,"rb");
		if(fp==NULL) ROM_TYPE=1;
		else {
			fread(BIOS,1,32768,fp);
			fclose(fp);
		}
	}
	if(ROM_TYPE==1){
		strcpy(str,PRG_PATH); strcat(str,"IPLROM.X1");
		fp=fopen(str,"rb");
		if(fp==NULL) ROM_TYPE=0;
		else {
			fread(BIOS,1,4096,fp);
			fclose(fp);
		}
	}

	return ROM_TYPE;
}

/***********************************************************************
	FONT & PCG
***********************************************************************/

static byte ANK08_80[16][8]={
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
	0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,
	0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,
	0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,
	0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,
	0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,
	0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,
	0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80
};

static byte ANK08_90[16][8]={
	0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0xff,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xff,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0xf8,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x0f,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0xff,0x08,0x08,0x08,
	0x00,0x00,0x00,0x00,0xf8,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0xf8,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x0f,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x0f,0x08,0x08,0x08,
	0x00,0x00,0x00,0x00,0xe0,0x10,0x08,0x08,
	0x08,0x08,0x08,0x04,0x03,0x00,0x00,0x00,
	0x08,0x08,0x08,0x10,0xe0,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x03,0x04,0x08,0x08,
	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01
};

static byte ANK16_80[16][16]={
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,
	0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,0xe0,
	0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,
	0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,
	0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,
	0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,
	0x01,0x01,0x02,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80
};

static byte ANK16_90[16][16]={
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xf8,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x0f,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xff,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xf8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0x20,0x10,0x10,0x08,0x08,0x08,0x08,
	0x08,0x08,0x08,0x08,0x08,0x04,0x04,0x02,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0xc0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x02,0x04,0x04,0x08,0x08,0x08,0x08,
	0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x02,0x02,0x01,0x01
};

short font_ini(void)
{
	FILE *fp;
	long  l,off;
	short i,err;
	byte str[128];

	err=0;

	memset(DMY_00,0x00,256);
	memset(DMY_FF,0xff,256);

	for(i=0; i<256; i++){
		X2TBL0[i]=0;
		if(i&0x80) X2TBL0[i]|=0xc0; if(i&0x40) X2TBL0[i]|=0x30;
		if(i&0x20) X2TBL0[i]|=0x0c; if(i&0x10) X2TBL0[i]|=0x03;
		X2TBL1[i]=0;
		if(i&0x08) X2TBL1[i]|=0xc0; if(i&0x04) X2TBL1[i]|=0x30;
		if(i&0x02) X2TBL1[i]|=0x0c; if(i&0x01) X2TBL1[i]|=0x03;
		X2TBLW[i] =(word)X2TBL1[i]; X2TBLW[i]<<=8;
		X2TBLW[i]|=(word)X2TBL0[i];
	}

	for(i=0; i<256; i++){
		memset(PCG_B[i],0,8);
		memset(PCG_R[i],0,8);
		memset(PCG_G[i],0,8);
	}

	//----- PCG -----

	strcpy(str,PRG_PATH); strcat(str,"PCG0808.X1");
	fp=fopen(str,"rb");
	if(fp!=NULL){
		for(i=0; i<256; i++) fread(PCG_B[i],1,8,fp);
		for(i=0; i<256; i++) fread(PCG_R[i],1,8,fp);
		for(i=0; i<256; i++) fread(PCG_G[i],1,8,fp);
		fclose(fp);
	}

	//----- ANK -----

	strcpy(str,PRG_PATH); strcat(str,"FNT0808.X1");
	fp=fopen(str,"rb");
	if(fp==NULL) err|=1;
	else {
		for(i=0; i<256; i++) fread(ANK_FNT[i],1,8,fp);
		fclose(fp);
	}

	// KM (99'06/10)
	for(i=0; i<16; i++){
		memcpy(ANK_FNT[0x80+i],ANK08_80[i],8);
		memcpy(ANK_FNT[0x90+i],ANK08_90[i],8);
	}

	//----- KANJI -----

	if(KNJ_FNT==NULL){
		KNJ_FNT=(byte *)malloc(0x4bc00);
		if(KNJ_FNT==NULL) return 8;
	}

	strcpy(str,PRG_PATH); strcat(str,"FNT0816.X1");
	fp=fopen(str,"rb");
	if(fp==NULL) err|=2;
	else {
		fread(KNJ_FNT,0x1000,1,fp);
		fclose(fp);
	}

	// KM (99'06/10)
	for(i=0; i<16; i++){
		memcpy(&KNJ_FNT[(0x80+i)*16],ANK16_80[i],16);
		memcpy(&KNJ_FNT[(0x90+i)*16],ANK16_90[i],16);
	}

	strcpy(str,PRG_PATH); strcat(str,"FNT1616.X1");
	fp=fopen(str,"rb");
	if(fp==NULL) err|=4;
	else {
		l=0x4ac00l; off=0x1000l;
		while(l>0x4000l){
			fread(&KNJ_FNT[off],0x4000,1,fp);
			off+=0x4000l; l-=0x4000l;
		}
		fread(&KNJ_FNT[off],l,1,fp);
		fclose(fp);
	}

	return err;
}

short font_end(void)
{
	FILE *fp;
	word i;
	byte str[80];

	//----- Font -----

	if(KNJ_FNT!=NULL) free(KNJ_FNT);

	//----- PCG -----

	strcpy(str,PRG_PATH); strcat(str,"PCG0808.X1");
	fp=fopen(str,"wb");
	if(fp==NULL) return 1;
	for(i=0; i<256; i++) fwrite(PCG_B[i],1,8,fp);
	for(i=0; i<256; i++) fwrite(PCG_R[i],1,8,fp);
	for(i=0; i<256; i++) fwrite(PCG_G[i],1,8,fp);
	fclose(fp);

	return 0;
}

/***********************************************************************
	[
***********************************************************************/

byte Z80_RDMEM(word adrs)
{
	if(adrs & 0x8000){
		adrs&=0x7fff;
		return RAM1[adrs];
	} else if(!ROM_SW){
		return RAM0[adrs];
	}
	return BIOS[adrs];
}

void Z80_WRMEM(word adrs, byte value)
{
	if(adrs & 0x8000){
		adrs&=0x7fff;
		RAM1[adrs]=value;
	} else {
		RAM0[adrs]=value;
	}
}

/***********************************************************************
	h^n
***********************************************************************/

void Z80_Out(word Port,byte Value)
{
	word hi;

	// ޳ޥ Ӱ
	if(IO_MODE){ x1_grp_w2(Port,Value); return; }

	// if(Port<0x2000) IOw[Port]=Value;

	if(Port>=0x4000){ x1_grp_w(Port,Value); return; }
	if(Port>=0x2000){ x1_txt_w(Port,Value); return; }

	if(Port==0x0b00){
		if(Value & 0x10) RAM0=MAIN0;
		else    RAM0=BANK[Value&15];
	} else if(Port==0x0700){
		x1_opm_reg(Value);
	} else if(Port==0x0701){
		x1_opm_datw(Value);
	}
	else if(Port==0x1800) x1_crtc_reg(Value);
	else if(Port==0x1801) x1_crtc_dat(Value);
	else if(Port>=0x0e80 && Port<=0x0e82) x1_knj_w(Port,Value);
	else if(Port>=0x0ff8 && Port<=0x0fff) x1_fdc_w(Port,Value);
	else if(Port>=0x1000 && Port<=0x12ff) x1_palet_w(Port,Value);
	else if(Port>=0x1400 && Port<=0x17ff) x1_pcg_w(Port,Value);
	else if(Port>=0x1f80 && Port<=0x1f8f) x1_dma_w(Port,Value);
	else if(Port>=0x1f90 && Port<=0x1f93) x1_sio_w(Port,Value);
	else if(Port>=0x0704 && Port<=0x0707 && OPM_MODE) x1_ctc_w(Port,Value);
	else if(Port>=0x1fa0 && Port<=0x1fa3) x1_ctc_w(Port,Value);
	else if(Port>=0x1fa8 && Port<=0x1fab) x1_ctc_w(Port,Value);
	else if(Port>=0x1fd0 && Port<=0x1fdf) x1_scrn_w(Value);
	else {
		hi=(Port>>8);
		if(     hi==0x13) x1_ply_w(Value);
		else if(hi==0x19) x1_sub_w(Port,Value);
		else if(hi==0x1a) x1_8255_w(Port,Value);
		else if(hi==0x1b) x1_psg_dat(Value);
		else if(hi==0x1c) x1_psg_reg(Value);
		else if(hi==0x1d) ROM_SW=1;
		else if(hi==0x1e){ ROM_SW=0; ROM_SW_VAL=Value; }
	}
}

byte Z80_In(word Port)
{
	word hi;
	byte ans,dmy;

	IO_MODE=0; // ݸ٥ Ӱ

	// ans=IOw[Port];
	ans=0xff;

	if(     Port>=0x4000) ans=x1_grp_r(Port);
	else if(Port>=0x2000) ans=x1_txt_r(Port);
	else if(Port==0x0701) ans=x1_opm_datr();
	else if(Port==0x1ff0) ans=DIP_SW;
	else if(Port>=0x0e80 && Port<=0x0e82) ans=x1_knj_r(Port);
	else if(Port>=0x0fe8 && Port<=0x0fef) ans=0xff;
	else if(Port>=0x0ff8 && Port<=0x0fff) ans=x1_fdc_r(Port);
	else if(Port>=0x1400 && Port<=0x17ff) ans=x1_pcg_r(Port);
	else if(Port>=0x1f80 && Port<=0x1f8f) ans=x1_dma_r(Port);
	else if(Port>=0x1f90 && Port<=0x1f93) ans=x1_sio_r(Port);
	else if(Port>=0x0704 && Port<=0x0707 && OPM_MODE) ans=x1_ctc_r(Port);
	else if(Port>=0x1fa0 && Port<=0x1fa3) ans=x1_ctc_r(Port);
	else if(Port>=0x1fa8 && Port<=0x1fab) ans=x1_ctc_r(Port);
	else if(Port>=0x1fd0 && Port<=0x1fdf) ans=x1_scrn_r();
	else {
		hi=(Port>>8);
		if(     hi==0x13) ans=x1_ply_r();
		else if(hi==0x19) ans=x1_sub_r(Port);
		else if(hi==0x1a) ans=x1_8255_r(Port);
		else if(hi==0x1b) ans=x1_psg_sta();
		else if(hi==0x0c) ans=0xff; // <- RS232C()
		// else if(hi==0x1e) ans=ROM_SW_VAL;
		// else if(hi==0x1e) ROM_SW=0;
	}

	// if(Port<0x2000) IOr[Port]=ans;

	return ans;
}

/***********************************************************************
	
***********************************************************************/

short reset_x1(void)
{
	Z80_Reset();

	RAM0=MAIN0;
	RAM1=MAIN1;
	ROM_SW=1;
	IO_MODE=0;

	if(init_fdc()) return 1;
	if(init_scpu()) return 1;
	if(init_8255()) return 1;
	if(init_crtc()) return 1;
	if(init_vram()) return 1;

	return 0;
}

/***********************************************************************
	s
***********************************************************************/

word exec_x1(void)
{
	short c_cnt,v_cnt2;
	short pag_cnt,skp_cnt;
	short draw_skip,wsw,i;

	reset_x1();

	memset(MAIN0,0,0x8000);
	memset(MAIN1,0,0x8000);
	ipl_load();

	if(       IPL_SKIP==1){
		if(SOFT_NUM){ if(!fd_boot1(SOFT_NUM-1)) MENU_SW=0; }
		else{         if(!fd_boot0()          ) MENU_SW=0; }
	} else if(IPL_SKIP==2){
		if(!tape_boot()) MENU_SW=0;
	}

	draw_skip=DRAW_SKIP;

	H_CNT=V_CNT=0;
	v_cnt2=0;
	if(WAITFLG==2){
		pag_cnt=skp_cnt=0;
		timer_ini(60);
	}
	wsw=1;

	END_SW=MENU_SW;
	for(;;){
		if(END_SW){
#if BOSS==1
			if(END_SW==99) break; // BOSS
#endif
			if(MENU_SW){
				if(WAITFLG==2) timer_end();
				cnf_menu();
				if(WAITFLG==2){ skp_cnt=pag_cnt=0; timer_ini(60); }
			}
			if(END_SW) break;
		}

		//------------------------------

		c_cnt=0;
		while(H_CNT<HDISP_CNT){
			debug_dsp();

			i=Z80_Execute();
			H_CNT+=i; c_cnt+=i;

			cmt_motor((long)i); // e[v
			x1_dma();
			if(WAITFLG==1 && wsw){ if(v_blank()) wsw=0; }
		}
		H_CNT%=HDISP_CNT;
		x1_ctc_int(c_cnt);

		//------------------------------

		if(!SYNC_MODE){
			V_DISP=(V_CNT< CRT_YL?1:0);
			V_SYNC=(V_CNT>=CRT_VS?1:0);
		} else {
			V_DISP^=1; V_SYNC=(V_DISP^1);
		}
		if(V_SYNC) VSYNC_FLG=0;
		if(V_CNT<CRT_YL){
			if(!draw_skip) disp_line(V_CNT);
		}

		V_CNT++;
		if(V_CNT>=CRT_VL){
			V_CNT=0;
			if(draw_skip) draw_skip--;
			else  draw_skip=DRAW_SKIP;

			opm_trace_cnt();
			x1_sub_int();
			pad_scan();
			if(CRT_UPDT) CRT_UPDT--;
		}

		//------------------------------

		v_cnt2++;
		if(v_cnt2>=VDISP_CNT){
			v_cnt2=0;
			if(WAITFLG==1){
				if(wsw){
					while(!v_blank());
					while( v_blank());
				} else {
					draw_skip++;
					if(draw_skip>400) draw_skip=0;
				}
				wsw=1;
			} else if(WAITFLG==2){
				if(pag_cnt==tcnt_get()){
					while(pag_cnt==tcnt_get());
					pag_cnt=0; tcnt_set(0);
				} else {
					pag_cnt++; skp_cnt++;
					if(skp_cnt>30){ skp_cnt=pag_cnt=0; tcnt_set(0); }
				}
			}
		}
	}

	if(WAITFLG==2) timer_end();

	x1_eject_fd(0); x1_eject_fd(1);
	x1_eject_fd(2); x1_eject_fd(3);
	cmt_eject();

	return 0;
}

//**********************************************************************

// 0=PC/AT 1=9801 2=9821
short chk_machine(void)
{
	static unsigned char str[]="NEC Corporation";
	unsigned char *rom;
	short i;

/* Watcom-C  װ (;_;)
	union REGS r;
	r.h.ah=0x0f;
	int386(0x10,&r,&r);
	if(r.h.ah!=0x0f) return 0; // PC-AT
*/

	rom=(unsigned char *)0xe8000l;
	rom+=0x0dee;
	for(i=0; str[i]; i++){
		if(str[i]!=rom[i]) return 0; // PC-AT
	}

	rom=(unsigned char *)0x045cl;
	if((*rom)&0x40) return 2; // PC-9821(256F)

	return 1; // PC-9801(16F)
}

/***********************************************************************
	OPMDRV.COM 풓`FbN
***********************************************************************/

short chk_opmdrv(void)
{
//static byte str[]="OPMDRV.COM_Ver1r";
//static byte str[]="OPMDRV.COM_Ver1p";
	static byte str[]="OPMDRV.COM";
	static word tbl[]={ 0x46,0x6a,0 };
	word *vct;
	byte *chk;
	unsigned long adr;
	short i,n;
	union REGS Regs;

	OPM_MODE=0;
	PSG_MODE=0;
	OPMDRV_IRQ=0;

	// AhX
	//   ZOg = xN^̃ZOg
	//   ItZbg = 103h
	// e
	//   "OPMDRV.COM_Ver1r"
	//   "OPMDRV.COM_Ver1p"
	for(n=0; tbl[n]; n++){
		vct=(word *)(tbl[n]*4);
		adr=((unsigned long)vct[1])<<4;
		chk=(byte *)(adr+0x103l);
		for(i=0; str[i] && str[i]==chk[i]; i++);
		if(!str[i]){ OPMDRV_IRQ=tbl[n]; break; }
	}

	if(!OPMDRV_IRQ) return 0;

	// Get version
	Regs.w.ax=0;
	int386(OPMDRV_IRQ,&Regs,&Regs);

	OPM_MODE=1;
	if(Regs.h.al>=20) PSG_MODE=1;

	return 0;
}

//**********************************************************************

short str2int(byte *str)
{
	short ans;

	ans=0;
	while(*str){
		if((*str)<'0') break;
		if((*str)>'9') break;
		ans=(ans*10)+(short)((*str)-'0');
		str++;
	}

	return ans;
}

word str2hex(byte *str)
{
	word ans,tmp;

	ans=0;
	while(*str){
		if(     (*str)>='0' && (*str)<='9') tmp=(short)((*str)-'0');
		else if((*str)>='a' && (*str)<='f') tmp=(short)((*str)-'a')+10;
		else if((*str)>='A' && (*str)<='F') tmp=(short)((*str)-'A')+10;
		ans=(ans<<4)|tmp;
		str++;
	}

	return ans;
}

int main(int argc,byte *argv[],byte *envp[])
{
	FILE *fp;
	byte *str,*s,*d;
	unsigned short hex;
	unsigned long lw;
	short wd,fdd;
	short i,n,err;

	//  EXE   ިڸ  ĸ
	i=n=0; s=argv[0]; d=PRG_PATH;
	while(s[i]){
		if(kanji_chk(s[i])){
			d[i]=s[i]; i++;
			d[i]=s[i]; i++;
		} else {
			if(s[i]==0x5c) n=(i+1); // 0x5c='\'
			d[i]=s[i]; i++;
		}
	}
	d[i]=0; d[n]=0;

	PC98FLG=99;
	MENU_SW=1;
	ROM_TYPE=2;
	DIP_SW=1; // ޳ 0:High 1:Low
	SYNC_MODE=0;
	KEY_MODE=0;
	WAITFLG=1;
	DRAW_SKIP=0;
	IPL_SKIP=0;
	SOFT_NUM=0;
	SOUND_SW=1;
//PSG_VOL=0;
	JOY_TYPE=0;
	JOY_NO=0;
	JOY_SKP=64;
	SndPrm=NULL;

	chk_opmdrv();

	cmt_eject();
	x1_eject_fd(0); x1_eject_fd(1);
	x1_eject_fd(2); x1_eject_fd(3);

	err=0; fdd=0;
	for(i=1; i<argc; i++){
		if(argv[i][0]=='-' || argv[i][0]=='/'){
			str=&argv[i][2];
			wd =str2int(str);
			hex=str2hex(str);
			n=(word)(argv[i][1])|0x20;
			switch(n){
				case 'c': cmt_set(0,str); break;
				case 'd':
					hex&=0x0f;
					DIP_SW=(DIP_SW&0xe1)|(hex<<1);
				break;
				case 'r':
					if(wd) DIP_SW&=~0x01;
					else   DIP_SW|= 0x01;
				break;
				case 't': ROM_TYPE=wd; break;
				case 'i': SOFT_NUM=wd; IPL_SKIP=1; break;
				case 'p': SOUND_SW=(wd?1:0); break;
				case 's': SYNC_MODE^=1; break;
				case 'v':
					lw=(unsigned long)hex;
					SndPrm=(struct SND_PRM *)(lw<<4l);
					OPM_MODE=PSG_MODE=2;
				break;
				case 'w': WAITFLG =wd; break;
				case 'k': KEY_MODE=wd; break;
				case 'u': DRAW_SKIP=wd; break;
				case 'a': PC98FLG=0; if(*str && wd) VSYNC_AT=wd; break;
				case '9': PC98FLG=1; if(*str && wd) VSYNC_AT=98; break;
				case '!': PC98FLG=2; if(*str && wd) VSYNC_AT=98; break;
				case 'n': BMP_NUM=wd; break;
				case 'm': MENU_SW=wd; break;
				case '$': JOY_PORT=hex; break;
				case '#': JOY_SKP = wd; break;
				case 'j':
					if(       (str[0]|0x20)=='s'){
						JOY_TYPE=1; JOY_NO=0;
						if(str[1]>='1' && str[1]<='5') JOY_NO=(str[1]-'1');
					} else if((str[0]|0x20)=='p'){
						JOY_TYPE=2; JOY_NO=0;
						if(str[1]>='1' && str[1]<='4') JOY_NO=(str[1]-'1');
					} else if((str[0]|0x20)=='k'){
						JOY_TYPE=9; JOY_NO=0;
					}
				break;
				default: err=1; break;
			}
		} else {
			str=argv[i]; for(n=0; str[n]; n++);
			if(     !strcmpi(&str[n-3],".2D" )) x1_set_fd(fdd,1,str);
			else if(!strcmpi(&str[n-4],".D88")) x1_set_fd(fdd,2,str);
			fdd=(fdd+1)%4;
		}
	}

	if(err){
		printf("\n%s\n\n",Title);
		printf("gp@\n");
		printf("  X1EMU [/߼] [FDҰ1] [FDҰ2]\n");
		printf("FDҰ\n");
		printf("  ЭڰFDײނɓFDҰ̧\n");
		printf("߼\n");
		printf("  /M0 ... j[EIt (f10őI)\n");
		printf("  /In ... IPL𽷯߂2DҰނ'n'Ԗڂ̧قN\n");
		printf("  /Tn ... IPL-ROM (0= 1=IPLROM.X1 2=IPLROM.X1T)\n");
		printf("  /Rn ... wP̉𑜓x   (n=0:STANDARD/1:HIGH)\n");
		printf("  /Dn ... fbvXCb` (16iP)\n");
		printf("  /Kn ... ް(n=0:m[} 1: 2:gȂ)\n");
		printf("  /Un ... ʂ̍XV'n'\n");
		printf("  /Wn ... EFCg (n=0:OFF/1:V-SYNC/2:TIMER)\n");
		printf("  /A  ... PC-ATӰ(ϼ)\n");
		printf("  /9  ... PC-98Ӱ(ϼ)\n");
		printf("  /!  ... PC-98Ӱ(ϼ ÷ON)\n");
		printf("  /A6000 ... PC-AT(ϼ) V-SYNC 60.00Hz\n");
		printf("  /97001 ... PC-98(ϼ) V-SYNC 70.01Hz\n");
		exit(1);
	}

	if(PC98FLG==99){
		PC98FLG=(chk_machine()?1:0);
	}

/*
	if(!JOY_TYPE){
		if(PC98FLG){ JOY_TYPE=4; JOY_NO=0; }
		else{        JOY_TYPE=3; JOY_NO=0; }
	}
*/

	// memset(IOr,0,0x2000);
	// memset(IOw,0,0x2000);

	err=font_ini();
	if(err){
		if(err & 7){
			printf("ERR:tHgt@C܂\n");
		}
		if(err & 8){
			printf("ERR:[܂\n");
			printf("    ϐ(DOS4GVM)mFĂ\n");
			printf("    SET DOS4GVM=maxmem#2048 \n");
		}
	} else {
		if(!init_machine()) exec_x1();
		term_machine();
	}
	font_end();

/*
	fp=fopen("io.log","wb");
	fwrite(IOr,1,0x2000,fp);
	fwrite(IOw,1,0x2000,fp);
	fclose(fp);
*/

	return 0;
}

