#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_tape.h"
#include "x1_vram.h"
#include "text.h"

unsigned long TAPE_FRQ=8000l;
unsigned long TAPE_STP=500l;
unsigned long TAPE_CNT=0l;
unsigned long TAPE_ADR=0l;

word APSS_CNT=4000;

word TAPE_WSW=0;
word TAPE_BIT=0;

short CMT_CMND =0;
short CMT_EJECT=1;
short CMT_STOP =1;
short CMT_PLAY =0;
short CMT_REC  =0;

//*********************************************************************

struct FEMS {
	unsigned char  fname[80];
	unsigned short page_num;
	unsigned short page_cnt;
	unsigned char  buff[0x4000];
};

static struct FEMS TAPE={0};

short FEMS_open(struct FEMS *fems,unsigned char *fname);
short FEMS_close(struct FEMS *fems);
short FEMS_realloc(struct FEMS *fems,unsigned short pag);
short FEMS_map_page(struct FEMS *fems,unsigned short pag);

/**********************************************************************
	JE^[\
**********************************************************************/

short CMT_DISP=0;

void cmt_disp_sw(short sw)
{
	if(sw==2) sw=(CMT_DISP?0:1);
	if(sw==0){
		if(!CMT_DISP) return;
		CMT_DISP=0;
		gmask_clr(65,24,79,24);
	} else {
		if(CMT_DISP) return;
		CMT_DISP=1;
		gmask_set(65,24,79,24);
		cmt_counter(1);
	}
}

void cmt_counter(short sw)
{
	static byte tbl[]="0123456789";
	static long _tim=0l;
	static byte _com=0;
	static byte _bit=0;
	short h,m,s;
	long t;
	byte str[16];

	if(!CMT_DISP) return;

	if(sw || _bit!=TAPE_BIT){
		_bit=TAPE_BIT; etext(65,24,2,0x26,_bit?"* ":"  ");
	}

	if(sw || _com!=CMT_CMND){
		_com=CMT_CMND;
		switch(CMT_CMND){
			case 0x00: etext(67,24,5,0x26,"EJECT"); break;
			case 0x01: etext(67,24,5,0x26,"STOP "); break;
			case 0x02: etext(67,24,5,0x26,"PLAY "); break;
			case 0x03: etext(67,24,5,0x26,"FF   "); break;
			case 0x04: etext(67,24,5,0x26,"REW  "); break;
			case 0x05: etext(67,24,5,0x26,"A-FF "); break;
			case 0x06: etext(67,24,5,0x26,"A-REW"); break;
			case 0x0a: etext(67,24,5,0x26,"REC  "); break;
			default:   etext(67,24,5,0x26,"?????"); break;
		}
	}

	t=(TAPE_ADR/TAPE_FRQ);
	if(sw || _tim!=t){
		_tim=t;
		s=(short)(t%60l); t/=60l;
		m=(short)(t%60l); t/=60l;
		h=(short)(t%60l);
		str[0]=tbl[h/10]; str[1]=tbl[h%10]; str[2]=':';
		str[3]=tbl[m/10]; str[4]=tbl[m%10]; str[5]=':';
		str[6]=tbl[s/10]; str[7]=tbl[s%10]; str[8]=0;
		etext(72,24,8,0x26,str);
	}
}

/**********************************************************************
	e[v̉]
**********************************************************************/

void cmt_motor(long cycle)
{
	TAPE_CNT+=cycle;
}

/**********************************************************************
	e[v̓^CWFNg {^ ɑ֐
**********************************************************************/

byte *get_cas_name(void)
{
	if(CMT_EJECT) return NULL;
	return TAPE.fname;
}

// sw ... 0=^ 1=^s
void cmt_set(short sw,byte *fname)
{
	FILE *fp;
	long frq;

	cmt_eject();

	fp=fopen(fname,"rb");
	if(fp==NULL) return;
	fread(&frq,1,4,fp);
	fclose(fp);

	CMT_EJECT=0;
	cmt_stop();
	TAPE_WSW=sw;
	TAPE_FRQ=frq;
	TAPE_STP=(4000000l/TAPE_FRQ);
	APSS_CNT=(TAPE_FRQ/8)*4;
	TAPE_ADR=0l;
	TAPE_BIT=0;

	FEMS_open(&TAPE,fname);

	cmt_counter(1);
}

void cmt_eject(void)
{
	CMT_CMND=0x00;

	CMT_PLAY=0;
	CMT_REC =0;
	CMT_STOP=1;
	CMT_EJECT=1;

	FEMS_close(&TAPE);

	cmt_counter(1);
}

/**********************************************************************
	Đ^^^~ {^ ɑ֐
**********************************************************************/

void cmt_play(void)
{
	if(CMT_EJECT) return;
	CMT_CMND=0x02;
	CMT_PLAY=1;
	CMT_REC =0;
	CMT_STOP=0;
	TAPE_CNT=0l;

	cmt_counter(1);
}

void cmt_rec(void)
{
	if(CMT_EJECT) return;
	if(TAPE_WSW ) return;
	CMT_CMND=0x0a;
	CMT_PLAY=0;
	CMT_REC =1;
	CMT_STOP=0;
	TAPE_CNT=0l;

	cmt_counter(1);
}

void cmt_stop(void)
{
	if(CMT_REC) cmt_write(0); // <- Ō̂Prbg

	CMT_CMND=0x01;
	CMT_PLAY=0;
	CMT_REC =0;
	CMT_STOP=1;

	cmt_counter(1);
}

/**********************************************************************
	^߂ {^ ɑ֐
**********************************************************************/

void cmt_ff(void)
{
	if(CMT_EJECT) return;
	if(CMT_REC) cmt_write(0); // <- Ō̂Prbg

	CMT_CMND=0x03;
	TAPE_ADR=(long)(TAPE.page_cnt)*0x4000l*8l;

	cmt_counter(1);
	cmt_stop();
}

void cmt_rew(void)
{
	if(CMT_EJECT) return;
	if(CMT_REC) cmt_write(0); // <- Ō̂Prbg

	CMT_CMND=0x04;
	TAPE_ADR=0l;

	cmt_counter(1);
	cmt_stop();
}

/**********************************************************************
	t ^߂ {^ ɑ֐
**********************************************************************/

void cmt_apss_ff(void)
{
	byte *buff;
	word pag,off;
	byte bit,dmy;
	byte sw0,sw1;
	long cnt0,cnt1;
	long lng0,lng1;
	long adr;

	if(CMT_EJECT) return;
	if(CMT_REC) cmt_write(0); // <- Ō̂Prbg

	CMT_CMND=0x05;
	if(     CMT_PLAY) CMT_CMND=0x02;
	else if(CMT_REC ) CMT_CMND=0x0a;
	else if(CMT_STOP) CMT_CMND=0x01;

	adr=TAPE_ADR;
	bit=0x80>>(adr%8l);
	adr/=8l; adr+=4l; // 擪SoCgǂݔ΂
	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);
	buff=TAPE.buff;

	lng0=(TAPE_FRQ*8l)/8000l;
	lng1=(TAPE_FRQ*2l)/lng0;

	sw0=sw1=0; cnt0=cnt1=0l;
	if(!FEMS_map_page(&TAPE,pag)){
		while(pag<TAPE.page_cnt){
			sw1=(TAPE.buff[off]&bit)?1:0;
			if(!sw0 && !sw1) cnt0++;
			else             cnt0=0;
			sw0=sw1;
			if(cnt0>=lng0){ cnt0=0l; cnt1++; }
			if(cnt1>=lng1) break;

			bit>>=1;
			if(!bit){
				bit=0x80; off++;
				if(off>=0x4000){
					off=0; pag++;
					if(FEMS_map_page(&TAPE,pag)) break;
				}
			}
		}
	}

	TAPE_ADR=((long)(pag*0x4000l)+(long)off)*8l;
	cmt_counter(1);
}

void cmt_apss_rew(void)
{
	byte *buff;
	word pag,off;
	byte bit,dmy;
	byte sw0,sw1;
	long cnt0,cnt1;
	long lng0,lng1;
	long adr;

	if(CMT_EJECT) return;
	if(CMT_REC) cmt_write(0); // <- Ō̂Prbg

	CMT_CMND=0x06;
	if(     CMT_PLAY) CMT_CMND=0x02;
	else if(CMT_REC ) CMT_CMND=0x0a;
	else if(CMT_STOP) CMT_CMND=0x01;

	adr=TAPE_ADR;
	bit=0x80>>(adr%8l);
	adr/=8l; adr+=4l; // 擪SoCgǂݔ΂
	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);
	buff=TAPE.buff;

	lng0=(TAPE_FRQ*8l)/8000l;
	lng1=(TAPE_FRQ*2l)/lng0;

	sw0=sw1=0; cnt0=cnt1=0l;
	if(!FEMS_map_page(&TAPE,pag)){
		while(pag){
			sw1=(TAPE.buff[off]&bit)?1:0;
			if(!sw0 && !sw1) cnt0++;
			else             cnt0=0;
			sw0=sw1;
			if(cnt0>=lng0){ cnt0=0l; cnt1++; }
			if(cnt1>=lng1) break;

			bit<<=1;
			if(!bit){
				bit=0x01;
				if(      off) off--;
				else if(!pag) break;
				else {
					off=0x3fff; pag--;
					if(FEMS_map_page(&TAPE,pag)) break;
				}
			}
		}
	}

	TAPE_ADR=((long)(pag*0x4000l)+(long)off)*8l;
	cmt_counter(1);
}

/**********************************************************************
	e[v̂Prbgo
**********************************************************************/

byte cmt_read(void)
{
	word pag,off,bit;
	long adr;

	if(CMT_EJECT) return 0;
	if(!CMT_PLAY) return 0;
	// if(!CMT_PLAY) return TAPE_BIT;

	TAPE_ADR+=(TAPE_CNT/TAPE_STP);
	TAPE_CNT%=TAPE_STP;

	adr=TAPE_ADR;
	// ξ
	if(TAPE_CNT>(TAPE_STP/3)) adr++;

	bit=0x80>>(adr%8l);
	adr/=8l;
	adr+=4l; // 擪SoCgǂݔ΂
	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);

	if(FEMS_map_page(&TAPE,pag)){
		cmt_stop();
		return 0;
	}

	TAPE_BIT=(TAPE.buff[off]&bit)?1:0;

	// ߰ް
	// if(TAPE_BIT) outp(0x35,inp(0x35)&0xf7);
	// else         outp(0x35,inp(0x35)|0x08);

	return TAPE_BIT;
}

void cmt_write(short dat)
{
	long tadr0,tadr1,adr;
	word pag,off,bit;
	short flg,sw;

	flg=TAPE_BIT;
	TAPE_BIT=dat;

	if(CMT_EJECT) return;
	if(TAPE_WSW ) return;
	if(!CMT_REC ) return;

	tadr0=TAPE_ADR;

	TAPE_ADR+=(TAPE_CNT/TAPE_STP);
	TAPE_CNT%=TAPE_STP;
	// ξ
	if(TAPE_CNT>((TAPE_STP/3)*2)) TAPE_ADR++;
	TAPE_CNT=0;

	tadr1=TAPE_ADR;

	adr=tadr0;
	bit=0x80>>(adr%8l);
	adr/=8l;
	adr+=4l; // 擪SoCgǂݔ΂
	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);

	sw=1;
	while(tadr0<tadr1){
		if(!bit){ bit=0x80; off++; }
		if(off>=0x4000){ off=0; pag++; sw=1; }
		if(sw){
			if(FEMS_map_page(&TAPE,pag)){
				if(FEMS_realloc( &TAPE,pag+1)){ cmt_stop(); return; }
				if(FEMS_map_page(&TAPE,pag  )){ cmt_stop(); return; }
			}
			sw=0;
		}
		if(flg) TAPE.buff[off]|= bit;
		else    TAPE.buff[off]&=~bit;
		bit>>=1; tadr0++;
	}
}

/**********************************************************************
	TubotfbLRg[ׂ̈ɃR[֐
**********************************************************************/

void cmt_ctrl(short cmnd)
{
	switch(cmnd){
		case 0x00: cmt_eject(); break;
		case 0x01: cmt_stop();  break;
		case 0x02: cmt_play();  break;
		case 0x03: cmt_ff();    break;
		case 0x04: cmt_rew();   break;
		case 0x05: cmt_apss_ff();  break;
		case 0x06: cmt_apss_rew(); break;
		case 0x0a: cmt_rec(); break;
	}
	CMT_CMND=cmnd;
}

byte cmt_tape_stat(void)
{
	long lng,adr;
	word ans;

	ans=0;
	if(!TAPE_WSW ) ans|=4; //  1=OK 0=ݼ
	if(!CMT_EJECT) ans|=2; //  0=ż 1=
	if(!CMT_EJECT){
		if(        CMT_REC){
			ans|=1; // 0=ðߴ
		} else if(CMT_PLAY){
			lng=(long)(TAPE.page_cnt)*0x4000l;
			lng+=(long)APSS_CNT; // <- 
			adr=(long)(TAPE_ADR)/8l;
			if(lng>adr) ans|=1; // 0=ðߴ
		}
	}

	return (byte)ans;
}

byte cmt_cntl_stat(void)
{
	return CMT_CMND;
}

byte cmt_test(void)
{
	cmt_counter(0);

	if(CMT_STOP){ CMT_STOP=0; return 1; }
	return 0;
}

/**********************************************************************
	e[v璼ڃu[gihokgȂj
**********************************************************************/

word TB_PAG,TB_OFF;
byte TB_BIT,TB_DAT;

short tb_ini(void)
{
	long adr;

	if(CMT_EJECT) return 1;

	cmt_stop();
	cmt_rew();
	cmt_apss_ff();

	adr=TAPE_ADR;
	TB_BIT=0x80>>(adr%8l); adr/=8l;
	TB_PAG=(word)(adr/0x4000l);
	TB_OFF=(word)(adr%0x4000l);

	return FEMS_map_page(&TAPE,TB_PAG);
}

short tb_end(void)
{
	cmt_stop();
	cmt_rew();
	return 0;
}

short tb_hl(void)
{
	TB_DAT=(TAPE.buff[TB_OFF]&TB_BIT)?1:0;

	TB_BIT>>=1;
	if(!TB_BIT){
		TB_BIT=0x80; TB_OFF++;
		if(TB_OFF>=0x4000){
			TB_OFF=0; TB_PAG++;
			if(FEMS_map_page(&TAPE,TB_PAG)) return 1;
		}
	}

	return 0;
}

short tb_bit(void)
{
	do{
		if(tb_hl()) return 1;
	}while(!TB_DAT);
	if(tb_hl()) return 1;

	return 0;
}

short tb_header(short cnt0,short cnt1,short cnt2)
{
	short no,cnt,err;

	no=err=0;
	while(!err){
		if(       no==0){ // 1=1000BIT
			for(cnt=0; cnt<1000; cnt++){
				if(tb_bit()){ err=1; break; }
				if(TB_DAT==0) break;
			}
			no++;
		} else if(no==1){ // 0=40BIT
			for(cnt=0; cnt<40; cnt++){
				if(tb_bit()){ err=1; break; }
				if(TB_DAT==1) break;
			}
			no=(cnt==40?2:0);
		} else if(no==2){ // 1=40BIT
			for(cnt=0; cnt<40; cnt++){
				if(tb_bit()){ err=1; break; }
				if(TB_DAT==0) break;
			}
			no=(cnt==40?3:0);
		} else if(no==3){
			if(tb_bit()){ err=1; break; }
			if(TB_DAT==1) break;
			no=0;
		}
	}

	return err;
}

short tb_byte(byte *byt,word *sum)
{
	short i;

	if(tb_bit()) return 1;
	(*sum)+=TB_DAT;
	if(TB_DAT!=1) return 2;

	(*byt)=0;
	for(i=0; i<8; i++){
		if(tb_bit()) return 1;
		(*sum)+=TB_DAT;
		(*byt)<<=1; if(TB_DAT) (*byt)|=1;
	}

	return 0;
}

/**********************************************************************
**********************************************************************/

// dlrhL̃nhEI[v
short FEMS_open(struct FEMS *fems,unsigned char *fname)
{
	FILE *fp;
	long lng;

	strcpy(fems->fname,fname);
	(fems->page_num)=0;
	(fems->page_cnt)=0;
	memset(fems->buff,0,0x4000);

	fp=fopen(fems->fname,"rb");
	if(fp!=NULL){
		lng=filelength(fileno(fp));
		(fems->page_cnt)=(word)((lng+0x3fffl)/0x4000l);
		fseek(fp,0l,SEEK_SET);
		fread(fems->buff,1,0x4000,fp);
		fclose(fp);
	}

	return 0;
}

// dlrhL̃nhEN[Y
short FEMS_close(struct FEMS *fems)
{
	FILE *fp;
	short err;

	err=0;
	if(!fems->fname[0]) return 0;

	// ޯ̧  ׯ
	if(fems->page_cnt){
		fp=fopen(fems->fname,"r+b");
		if(fp==NULL) err=2; else {
			fseek(fp,(long)(fems->page_num)*0x4000l,SEEK_SET);
			if(fwrite(fems->buff,1,0x4000,fp)!=0x4000) err=2;
			fclose(fp);
		}
	}

	fems->fname[0]=0;

	return err;
}

// _y[Wݒ肷(dlrallocreallocɑ܂)
short FEMS_realloc(struct FEMS *fems,unsigned short pag_cnt)
{
	FILE *fp;
	short err;

	if(!fems->fname[0]) return 1;
	if(pag_cnt==(fems->page_cnt)) return 0;

	err=0;

	fp=fopen(fems->fname,"r+b");
	if(fp==NULL){
		fp=fopen(fems->fname,"wb");
		if(fp==NULL) return 2;
	}
	if(chsize(fileno(fp),(long)pag_cnt*0x4000l)) err=3;
	else (fems->page_cnt)=pag_cnt;
	fclose(fp);

	return err;
}

// _y[W̃}bsO
// (AP[gĂȂy[W̃}bsO̓G[ł)
short FEMS_map_page(struct FEMS *fems,unsigned short pag)
{
	FILE *fp;
	short err;

	if(!fems->fname[0]) return 1;
	if(pag>=(fems->page_cnt)) return 1;
	if(pag==(fems->page_num)) return 0;

	err=0;

	// ܃}bsOĂy[Wt@C֏o
	fp=fopen(fems->fname,"r+b");
	if(fp==NULL) err|=2; else {
		fseek(fp,(long)(fems->page_num)*0x4000l,SEEK_SET);
		if(fwrite(fems->buff,1,0x4000,fp)!=0x4000) err|=2;
		fclose(fp);
	}

	// w肳ꂽy[Wt@Cǂݍ
	fp=fopen(fems->fname,"rb");
	if(fp==NULL) err|=1; else {
		(fems->page_num)=pag;
		fseek(fp,(long)(fems->page_num)*0x4000l,SEEK_SET);
		if(fread( fems->buff,1,0x4000,fp)!=0x4000) err|=1;
		fclose(fp);
	}

	return err;
}

short FEMS_read(struct FEMS *fems,dword adr,short cnt,void *data)
{
	byte *des,*src;
	word pag,off,n;

	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);
	if(FEMS_map_page(fems,pag)) return 1;

	des=(byte *)data;
	src=(byte *)(&fems->buff[off]);

	if(off+cnt<=0x4000){
		memcpy(des,src,cnt);
	} else {
		n=(0x4000-off);
		memcpy(des,src,n);
		if(FEMS_map_page(fems,pag+1)) return 1;
		memcpy(&des[n],fems->buff,cnt-n);
	}

	return 0;
}

short FEMS_write(struct FEMS *fems,dword adr,short cnt,void *data)
{
	byte *des,*src;
	word pag,off,n;

	pag=(word)(adr/0x4000l);
	off=(word)(adr%0x4000l);
	if(FEMS_map_page(fems,pag)) return 1;

	src=(byte *)data;
	des=(byte *)(&fems->buff[off]);
	if(off+cnt<=0x4000){
		memcpy(des,src,cnt);
	} else {
		n=(0x4000-off);
		memcpy(des,src,n);
		if(FEMS_map_page(fems,pag+1)) return 1;
		memcpy(fems->buff,&src[n],cnt-n);
	}

	return 0;
}

//*********************************************************************

short tape_boot(void)
{
	struct X1_DIR info;
	word sum0,sum1,adr;
	word i,no,err;
	byte *tmp;

	err=tb_ini();

	no=0;
	while(!err){
		if(       no==0){ // 
			no=1; do{ err=tb_hl(); }while(!err && !TB_DAT);
		} else if(no==1){ // ͯ1
			no=2; err=tb_header(1000,40,40);
		} else if(no==2){ // ̫Ұݥۯ (32byte)
			no=3; tmp=(byte *)&info;
			for(i=sum0=0; i<32 && !err; i++) err=tb_byte(&tmp[i],&sum0);
		} else if(no==3){ //  & įߥޯ=1
			tmp=(byte *)&sum1;
			err=tb_byte(&tmp[0],&i); if(err) break;
			err=tb_byte(&tmp[1],&i); if(err) break;
			if(tb_bit()){ err=1; break; }
			no=(TB_DAT==1 && sum0==sum1)?4:0;
		} else if(no==4){ // ͯ2
			no=5; err=tb_header(3000,20,20);
		} else if(no==5){ // ް
			no=6;
			adr=info.top_adr;
			for(i=sum0=0; i<info.size && !err; i++){
				if(adr<0x8000) err=tb_byte(&MAIN0[adr       ],&sum0);
				else           err=tb_byte(&MAIN1[adr-0x8000],&sum0);
				adr++;
			}
		} else if(no==6){ //  & įߥޯ=1
			tmp=(byte *)&sum1;
			err=tb_byte(&tmp[0],&i); if(err) break;
			err=tb_byte(&tmp[1],&i); if(err) break;
			if(tb_bit()){ err=1; break; }
			no=(TB_DAT==1 && sum0==sum1)?7:0;
		} else if(no==7){
			reset_x1();
			ROM_SW=0;
			Z80_SetPC(info.sta_adr);
			break;
		}
	}

	tb_end();

	return err;
}

